View Issue Details

IDProjectCategoryView StatusLast Update
0000342VisualDifferFolders differpublic2021-12-06 07:53
ReportertkmantisAssigned Toadmin 
PriorityhighSeverityfeatureReproducibilityalways
Status assignedResolutionopen 
Product Version1.8.2 
Target VersionFixed in Version 
Summary0000342: Would like to find differences in labels or tags assigned to folders.
DescriptionVisual Differ already can find differences in labels or tags assigned to files. I would like it to also be able to check the labels or tags on folders when I compare two folder trees. Thanks.
Steps To ReproduceSet up two identical folder trees. Assign a finder label or tag to a buried folder in one of the trees. Perform the comparison with Compare finder tags or Compare finder labels enabled. Visual differ won't spot the difference.
TagsNo tags attached.

Activities

admin

2021-10-31 07:56

administrator   ~0000665

The current implementation compares only files, I admit this is too restrictive for tags and label so I will try to achieve a valid result

tkmantis

2021-11-01 02:07

reporter   ~0000669

The main thing I want to compare about the folders themselves, is to detect if they have differing tags or labels, and, of course, the ability to easily identify oddball buried empty folders (which has its own ticket). If you decide to compare timestamps of folders, I would want to turn that off, while still checking timestamps of the files within, and the labels and tags of all the folders and all the files. And I think comparison of sizes or contents only makes sense with files.

tkmantis

2021-11-06 17:27

reporter   ~0000674

Thanks for fixing 0000320! How is your progress on this related issue?

admin

2021-11-07 07:35

administrator   ~0000675

At time time this feature can't be fixed because VD compares only files not folders, folders are excluded by any comparison combination because they are considered only "containers"
Tags and labels are the only cases when comparing folders makes sense but I introduced this feature as an experiment and comparing tags for files was enough, probably you and me are the only users using it

tkmantis

2021-11-07 20:43

reporter   ~0000676

I am curious why you say this can't be fixed. VD already detects buried empty folders, so its data structures or object model must already have a concept for folders. This request is only asking to track the label and tag attributes of the folders. This is a feature that I really want and I hope you can do it. I wouldn't mind if it must be turned on with a check box in the session preferences and it would be OK if turning it on would cause additional processing time for a second pass through the folders, if that is what it takes. It would even be OK if this had to be an entirely separate type of compare that is only for folders that has to be run separately, while still presenting the result visuallly. (The only way I currently have to compare folder tags or labels is a clunky command line solution that involves generating and comparing output report text files, and makes it very clunky for me to get to folder to make the tags consistent.)

admin

2021-11-08 06:18

administrator   ~0000677

Obviously internally the folders are trasversed, in some situations if the found element is a folder the comparison is totally skipped (for performance reasons and so on) so I need to check for regressions.

Consider I say "At time time" the problem can't be fixed, this means it requires many new checks, and a bunch or regression tests.
I can't give you a deadline but I can say I will try to implement this feature very soon

PS
Have you updated VD?
The fix for "0000320: Folder compare fails to detect a buried empty folder not on other side" is now fine for you?

tkmantis

2021-11-08 07:29

reporter   ~0000678

Thanks for your reply and for planning to include the change requested in this ticket. I understand you need some time to implement it. Please take the time you need to complete the feature well and I look forward to seeing it when it is ready. I did not update yet for the other one, but will very soon.

admin

2021-11-15 06:28

administrator   ~0000685

Honestly no progress, I tried to add the new processing but many checks stopped to work, this feature requires a deep refactor so I'm working slowly on it

tkmantis

2021-11-15 16:23

reporter   ~0000687

Thanks for the update. After this issue is completed, I would expect that "Only Mismatches" when combined with the new "Check Folder Tags and Labels" option would show top level folders if there are differences in tags or labels on the top level folders or on buried folders, even if such folders are otherwise the same.

admin

2021-11-16 10:44

administrator   ~0000689

Just to be honest, this feature is not a priority and its implementation is a bit complex so I can't give you any deadline

admin

2021-12-04 11:39

administrator   ~0000702

Last edited: 2021-12-04 11:39

View 2 revisions

Just first fix, the road is long...

As you can see on screenshot now folders with tags are matched.

https://visualdiffer.com/vdbugs-screenshots/bug342/bug342_fix_01.png

The screenshot considers 3 scenarios

1. left and right folders have tags identical
2. left and right folders have tags NOT identical
3. left folder contains tag, right folder doesn't contain tags

Any hints? do you this results?

tkmantis

2021-12-04 19:05

reporter   ~0000703

Thank you for working on this! Your screenshot looks correct. Two optional ideas:
1) Use a special color for differences, if the difference is only in tags/labels
2) Provide a button on the top bar next to "empty" to show/hide tags/labels differences.
Even without either of these ideas, I will be delighted to have the new feature, where the tags/labels differences just simply show.

admin

2021-12-05 11:34

administrator   ~0000704

Oh Gosh! I'm so bad to pick colors?

I chosen this purple for Light Theme

https://visualdiffer.com/vdbugs-screenshots/bug342/bug342_colors.png

If you have a better choice tell me!!

About button to toggle tags/labels it sounds good but I want to think better...

tkmantis

2021-12-05 17:21

reporter   ~0000705

OK on the color. You might also use the new color on the containing folders, in place of red, if the differences are limited to labels/tags. However in your example, you have both label/tag differences and other differences, so the folders should be red (red should trump purple if both could apply, when coloring each folder or file).

admin

2021-12-06 07:53

administrator   ~0000706

> You might also use the new color on the containing folders, in place of red, if the differences are limited to labels/tags

Do you mean the icon color?
Folders can differ in tags so also them must be colored.

The parent folders containing ONLY mismatching tags/labels must have the icon in "purple" but the text in "black" (as usual)
The folders having different tags/labels must have text color in "purple" in the same manner files.

Issue History

Date Modified Username Field Change
2021-10-29 20:13 tkmantis New Issue
2021-10-29 20:13 tkmantis Status new => assigned
2021-10-29 20:13 tkmantis Assigned To => admin
2021-10-31 07:56 admin Note Added: 0000665
2021-11-01 02:07 tkmantis Note Added: 0000669
2021-11-06 17:27 tkmantis Note Added: 0000674
2021-11-07 07:35 admin Note Added: 0000675
2021-11-07 20:43 tkmantis Note Added: 0000676
2021-11-08 06:18 admin Note Added: 0000677
2021-11-08 07:29 tkmantis Note Added: 0000678
2021-11-15 06:28 admin Note Added: 0000685
2021-11-15 16:23 tkmantis Note Added: 0000687
2021-11-16 10:44 admin Note Added: 0000689
2021-12-04 11:39 admin Note Added: 0000702
2021-12-04 11:39 admin Note Edited: 0000702 View Revisions
2021-12-04 19:05 tkmantis Note Added: 0000703
2021-12-05 11:34 admin Note Added: 0000704
2021-12-05 17:21 tkmantis Note Added: 0000705
2021-12-06 07:53 admin Note Added: 0000706